#include <bits/stdc++.h>

using namespace std;

#ifdef TEST
#   define DEBUG(x) cout << (x) << endl
#else
#   define DEBUG(x)
#endif

void print(int a[], int n) {
    for(int i = 0; i < n; i++) cout << a[i] << " ";
    cout << endl;
}

int main() {
    int a[] = {1, 3, 6, 9, 9, 3, 5, 9};
    print(a, 8);
    sort(a, a + 8);
    print(a, 8);
    
    {
        auto res = lower_bound(a, a + 8, 4);
        cout << "first element >= 4 is a[" << (res - a) << "] = " << *res << endl;
    }
    {
        auto res = upper_bound(a, a + 8, 5);
        cout << "first element >  5 is a[" << (res - a) << "] = " << *res << endl;
    }
    {
        auto res = equal_range(a, a + 8, 3);
        cout << "first element >= 3 is a[" << (res.first - a) << "] = " << *res.first << "; ";
        cout << "first element > 3 is a[" << (res.second - a) << "] = " << *res.second << "; ";
        cout << "there are " << (res.second - res.first) << " occurrences of 3" << endl;
    }
    return 0;
}

