#include <bits/stdc++.h>

using namespace std;

#ifdef TEST
#   define DEBUG(x) cout << (x) << endl
#else
#   define DEBUG(x)
#endif

void counting_sort(int max, int a[], int n) {
    int count[max + 1];
    for(int i = 0; i <= max; i++) count[i] = 0;
    
    // bookkeeping
    for(int i = 0; i < n; i++) count[a[i]]++;
    
    // sort
    for(int i = 0, k = 0; i <= max; i++) for(int j = 0; j < count[i]; j++) a[k++] = i;
}

void print(int a[], int n) {
    for(int i = 0; i < n; i++) cout << a[i] << " ";
    cout << endl;
}

int main() {
    int a[] = {1, 3, 6, 9, 9, 3, 5, 9};
    print(a, 8);
    counting_sort(9, a, 8);
    print(a, 8);
    return 0;
}

